import * as React from 'react';
import { Grid, Input, Form, Checkbox, Divider } from 'semantic-ui-react';

export class ListContainer extends React.Component<any, any> {

  private found: boolean = false;

  constructor(props: any, context: any) {
    super(props, context);
    this.state = {
    };

  }

  handleSearch(e: any, data: any) {
    let searchWord = data.value;
    let items: object[];
    items = this.props.data;
    let item: any;

    let result = new Array();
    for (item of items) {
      this.search(item, searchWord);
      if (this.found) {
        result.push(item);
      }
      this.found = false;
    }

    this.props.onSearch(result);
  }

  handleSearchInput(e: any, data: any) {
    this.setState({
      searchWord: data.value,
    });
  }

  search(item: any, searchWord: string) {
    let key: any;
    for (key in item) {
      if (this.isString(item[key])) {
        if (item[key].toLowerCase().indexOf(searchWord.toLowerCase()) !== -1) {
          this.found = true;
        }
      } else {
        this.search(item[key], searchWord);
      }
    }
  }

  isString(val: any): boolean {
    if (typeof val === 'string') {
      return true;
    }
    return false;
  }

  render() {
    return (
      <Grid>
        <Grid.Column width={4}>
          <Input icon='search' label={{ icon: 'asterisk' }}
            labelPosition='left corner' placeholder='Search...' onChange={this.handleSearch.bind(this)} fluid/>
          <Divider />
          {this.props.filter}
        </Grid.Column>
        <Grid.Column stretched width={12} >
          {this.props.contents}
        </Grid.Column>
      </Grid>
    );
  }
}